Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/index.html
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/index.html	(revision 31621)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/web-portal/index.html	(revision 31623)
@@ -166,5 +166,5 @@
             <div class="col-md-12">
 
-	      <h2>Unigram Paged-based Extracted Feature Search (Prototype)</h2>
+	      <h2>Unigram Page-based Extracted Feature Search (Prototype)</h2>
 	      <form action="http://solr1.ischool.illinois.edu/solr/htrc-full-ef20/select" id="search-form">
 		<input type="hidden" id="indent" name="indent" value="on"/>
@@ -172,4 +172,5 @@
 		<input type="hidden" id="start" name="start" value="0"/>
 		<input type="hidden" id="rows" name="rows" value="20"/>
+
 		<input type="text"   class="search-in-progress" id="q" name="q" style="width: 600px;"/>
 		<input type="submit" class="search-in-progress" id="search-submit" />
@@ -179,97 +180,5 @@
 		
 		<div id="pos-fieldsets">
-		</div>
-		
-<!--
-		<fieldset>
-		  <legend style="margin-bottom: 5px; padding-top: 15px;">
-		    <input type="checkbox" name="en-enabled" id="en-enabled" checked="checked" />
-		    English:
-		  </legend>
-		  <div id="en-pos-choice">
-		  <input type="checkbox" name="en-VERB-htrctoken-cb" id="en-VERB-htrctoken-cb">
-		  <label for="en-VERB-htrctoken-cb"
-			 title="Verbs (all tenses and modes)">Verbs</label>
-		  &nbsp;
-		  <input type="checkbox" name="en-NOUN-htrctoken-cb" id="en-NOUN-htrctoken-cb">
-		  <label for="en-NOUN-htrctoken-cb"
-			 title="Nouns (common and proper)">Nouns</label>
-		  &nbsp;
-		  <input type="checkbox" name="en-ADJ-htrctoken-cb" id="en-ADJ-htrctoken-cb">
-		  <label for="en-ADJ-htrctoken-cb">Adjectives</label>
-		  &nbsp;
-		  <input type="checkbox" name="en-ADV-htrctoken-cb" id="en-ADV-htrctoken-cb">
-		  <label for="en-ADV-htrctoken-cb">Adverbs</label>
-		  &nbsp;
-		  <input type="checkbox" name="en-ADP-htrctoken-cb" id="en-ADP-htrctoken-cb">
-		  <label for="en-ADP-htrctoken-cb"
-			 title ="adpositions (prepositions and postpositions)">Adpositions</label>
-		  &nbsp;
-		  <input type="checkbox" name="en-CONJ-htrctoken-cb" id="en-CONJ-htrctoken-cb">
-		  <label for="en-CONJ-htrctoken-cb">Conjunction</label>
-		  &nbsp;
-		  <input type="checkbox" name="en-DET-htrctoken-cb" id="en-DET-htrctoken-cb">
-		  <label for="en-DET-htrctoken-cb">Determiners</label>
-		  &nbsp;
-		  <input type="checkbox" name="en-NUM-htrctoken-cb" id="en-NUM-htrctoken-cb">
-		  <label for="en-NUM-htrctoken-cb"
-			 title="Cardinal numbers">Numbers</label>
-		  &nbsp;
-		  <input type="checkbox" name="en-PRT-htrctoken-cb" id="en-PRT-htrctoken-cb">
-		  <label for="en-PRT-htrctoken-cb"
-			 title="Particles or other function words">Particles</label>
-		  &nbsp;
-		  <input type="checkbox" name="de-X-htrctokde-cb-" id="de-X-htrctokde-cb-10">
-		  <label for="en-X-htrctoken-cb0"
-			 title="Other words, such as foreign words, typos, abbreviations">Other</label>
-		  </div>
-		</fieldset>
-
-
-		<fieldset>
-		  <legend style="margin-bottom: 5px; padding-top: 15px;">
-		    <input type="checkbox" name="de-enabled" id="de-enabled" />
-		    German:
-		  </legend>
-		  <div id="de-pos-choice">
-		  <input type="checkbox" name="de-VERB-htrctokde-cb" id="de-VERB-htrctokde-cb">
-		  <label for="de-VERB-htrctokde-cb"
-			 title="Verbs (all tenses and modes)">Verbs</label>
-		  &nbsp;
-		  <input type="checkbox" name="de-NOUN-htrctokde-cb" id="de-NOUN-htrctokde-cb">
-		  <label for="de-NOUN-htrctokde-cb"
-			 title="Nouns (common and proper)">Nouns</label>
-		  &nbsp;
-		  <input type="checkbox" name="de-ADJ-htrctokde-cb" id="de-ADJ-htrctokde-cb">
-		  <label for="de-ADJ-htrctokde-cb">Adjectives</label>
-		  &nbsp;
-		  <input type="checkbox" name="de-ADV-htrctokde-cb" id="de-ADV-htrctokde-cb">
-		  <label for="de-ADV-htrctokde-cb">Adverbs</label>
-		  &nbsp;
-		  <input type="checkbox" name="de-ADP-htrctokde-cb" id="de-ADP-htrctokde-cb">
-		  <label for="de-ADP-htrctokde-cb"
-			 title ="adpositions (prepositions and postpositions)">Adpositions</label>
-		  &nbsp;
-		  <input type="checkbox" name="de-CONJ-htrctokde-cb" id="de-CONJ-htrctokde-cb">
-		  <label for="de-CONJ-htrctokde-cb">Conjunction</label>
-		  &nbsp;
-		  <input type="checkbox" name="de-DET-htrctokde-cb" id="de-DET-htrctokde-cb">
-		  <label for="de-DET-htrctokde-cb">Determiners</label>
-		  &nbsp;
-		  <input type="checkbox" name="de-NUM-htrctokde-cb" id="de-NUM-htrctokde-cb">
-		  <label for="de-NUM-htrctokde-cb"
-			 title="Cardinal numbers">Numbers</label>
-		  &nbsp;
-		  <input type="checkbox" name="de-PRT-htrctokde-cb" id="de-PRT-htrctokde-cb">
-		  <label for="de-PRT-htrctokde-cb"
-			 title="Particles or other function words">Particles</label>
-		  &nbsp;
-		  <input type="checkbox" name="de-X-htrctokde-cb-" id="de-X-htrctokde-cb-10">
-		  <label for="de-X-htrctokde-cb0"
-			 title="Other words, such as foreign words, typos, abbreviations">Other</label>
-		  </div>
-		</fieldset>
--->
-
+		</div>		
 
 		<fieldset class="show-hide-lang">